//-----------------------------------------------------------------------------------------// 
// +-------------------------------------------------------------------------------------+ //
// |                                     PX4_FX.mq4                                      | //
// |                               N Roets Copyright 2006                                | //
// |                               Works on M15 timeframe                                | //
// |                      Place on USDCHFm, USDJPYm, EURUSDm & GBPUSDm                   | //
// +-------------------------------------------------------------------------------------+ //
//-----------------------------------------------------------------------------------------// 

#property copyright "Nico Roets Copyright  2006"

extern double lots= 0.1;
extern int MaxTrades=1;
extern bool ManageMoney = false;
extern int Risk = 2;
extern bool ProfitTrailing = true;  
extern bool UseSound = true;  

extern int StopLoss = 35;
extern int TakeProfit = 100;
extern int TrailingStop = 20 ;   
int TrailingStep = 1;   
string NameFileSound  = "expert.wav";  


int IDT;
void deinit() {
   Comment("");
}

//--------------------------------------------------------------------------------------// 

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && IDT==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//--------------------------------------------------------------------------------------// 

int start(){

 for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      TrailingPositions();
    }
  }

   if(orderscnt()<MaxTrades){
      if(ManageMoney==true) lots = LotSize();
      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
      //if(CurTime()-OrderOpenTime()<61) return(0);
      
   }   
}

//--------------------------------------------------------------------------------------// 

void CheckOpen(){
 
  bool Buy, Sell;

//double RSI1 =iRSI(NULL,5,14,PRICE_CLOSE,2);
//double RSI2 =iRSI(NULL,5,14,PRICE_CLOSE,1);

//double RSI3 =iRSI(NULL,15,14,PRICE_CLOSE,1);
//double RSI4 =iRSI(NULL,5,14,PRICE_CLOSE,0);

//double RSI5 =iRSI(NULL,30,14,PRICE_CLOSE,1);

double RSI =iRSI(NULL,15,14,PRICE_CLOSE,0);

//double Ma1 = iMA(NULL,15,3,0,MODE_EMA,PRICE_CLOSE,0);
//double Ma2 = iMA(NULL,15,5,0,MODE_EMA,PRICE_CLOSE,0);
//double Ma3 = iMA(NULL,15,7,0,MODE_EMA,PRICE_CLOSE,0);
//double Ma4 = iMA(NULL,15,9,0,MODE_EMA,PRICE_CLOSE,0);
//double Ma5 = iMA(NULL,15,11,0,MODE_EMA,PRICE_CLOSE,0);

double sto1 = iStochastic (NULL,15,5,3,3,MODE_EMA,0,MODE_MAIN,0);
double sto2 = iStochastic (NULL,15,5,3,3,MODE_EMA,0,MODE_SIGNAL,0);
double sto3 = iStochastic (NULL,30,5,3,3,MODE_EMA,0,MODE_MAIN,0);
double sto4 = iStochastic (NULL,30,5,3,3,MODE_EMA,0,MODE_SIGNAL,0);
double sto5 = iStochastic (NULL,60,5,3,3,MODE_EMA,0,MODE_MAIN,0);
double sto6 = iStochastic (NULL,60,5,3,3,MODE_EMA,0,MODE_SIGNAL,0);

double   Macd1 =iMACD(NULL,30,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
double   Signal1 =iMACD(NULL,30,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);

//double   Macd2 =iMACD(NULL,60,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
//double   Signal2 =iMACD(NULL,60,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
double O = iOpen(NULL,PERIOD_M15,0);
double B = iHigh(NULL,PERIOD_D1,1);
double S = iLow(NULL,PERIOD_D1,1);




Buy = False;
if ( O > B && RSI > 50 && sto1 > sto2 && sto3 > sto4 && sto5 > sto6  )
Buy = True;

Sell = False;
if ( O < S && RSI < 50 && sto1 < sto2 && sto3 < sto4 && sto5 < sto6  )
Sell = True;

  
   double TP,SL;
//--------------------------------------------------------------------------------------// 
   if (Buy){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      OrderSend(Symbol(),OP_BUY,lots,Ask,1,SL,TP,"PX4",IDT,0,LawnGreen); 
   }
   if (Sell){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      OrderSend(Symbol(),OP_SELL,lots,Bid,1,SL,TP,"PX4",IDT,0,HotPink); 
   }
}
//--------------------------------------------------------------------------------------// 
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 1000)/10;  
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 50) lotMM = 50;
   return (lotMM);
} 
//--------------------------------------------------------------------------------------// 
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) 
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) 
    {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) 
      {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) 
  {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) 
    {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) 
      {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
//--------------------------------------------------------------------------------------// 
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,Yellow);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//--------------------------------------------------------------------------------------// 

